## magics++ 4.16.0+really4.16.0

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
find_package( ecbuild 3.4 REQUIRED )

project( magics VERSION 4.16.0 LANGUAGES CXX )

# make sure that the header files are installed into include/magics
# note that this needs to be done before ecbuild_declare_project()
# to ensure that the ecbuild header files are also put there
# note also that we need to CACHE this so that ecbuild_declare_project() does not overwrite it
set(INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")

include(ecbuild_system NO_POLICY_SCOPE)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_C_STANDARD 99)

###############################################################################
# some build options for this project


ecbuild_add_option( FEATURE CAIRO
                    DEFAULT ON
                    DESCRIPTION "cairo support[png/jpeg]"
                    REQUIRED_PACKAGES PangoCairo)

ecbuild_add_option( FEATURE DOCUMENTATION
                    DEFAULT OFF
                    DESCRIPTION "Adding support for automatic documentation"
                  )


string(STRIP "${PANGOCAIRO_LIBRARIES}" PANGOCAIRO_LIBRARIES)
if(PANGOCAIRO_FOUND)
 set(HAVE_CAIRO ON)
  ecbuild_enable_feature( CAIRO )
endif()

ecbuild_add_option( FEATURE GEOTIFF
                    DEFAULT OFF
                    DESCRIPTION "geotiff support [implies cairo] -  work on progress"
                    CONDITION HAVE_CAIRO
                    REQUIRED_PACKAGES GeoTIFF )

ecbuild_add_option( FEATURE WEBP
                    DEFAULT OFF
                    DESCRIPTION "webp support [implies cairo]"
                    CONDITION HAVE_CAIRO
                    REQUIRED_PACKAGES WEBP )

ecbuild_add_option( FEATURE NETCDF
                    DEFAULT ON
                    DESCRIPTION "enable netcdf support"
                    REQUIRED_PACKAGES "NetCDF 4 COMPONENTS C" )


ecbuild_add_option( FEATURE ODB
                    DEFAULT OFF
                    DESCRIPTION "ODB support - to be deprecated"
                    REQUIRED_PACKAGES "odc" )

ecbuild_add_option( FEATURE METVIEW
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface" )

ecbuild_add_option( FEATURE METVIEW_NO_QT
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface without Qt" )

ecbuild_add_option( FEATURE EFAS
                    DEFAULT OFF
                    DESCRIPTION "enable EFAS coastlines and catchments" )


set( MAGICS_NAME          "Magics" )
set( MAGICS_INSTALL_PATH  ${CMAKE_INSTALL_PREFIX} )


###############################################################################
### Metview and Qt
ecbuild_info("TESTING for Metview and Qt ...")

if(HAVE_METVIEW AND HAVE_METVIEW_NO_QT)
    ecbuild_critical("Do not set both HAVE_METVIEW and HAVE_METVIEW_NO_QT - only set one. You may have to remove your CMakeCache.txt to clear these settings.")
endif()

set( qt no )
set( metview no )

if( HAVE_METVIEW_NO_QT )
	set( metview yes )
	unset(MAGICS_ONLY)
endif()

if( HAVE_METVIEW )
    set ( metview yes)
    ecbuild_info("TESTING for Qt6 ...")
    unset(MAGICS_ONLY)

    find_package(Qt6Widgets)
    if( Qt6Widgets_FOUND )
        ecbuild_info("Qt6 was found ... ${Qt6Widgets_VERSION_STRING}")
        include_directories(${Qt6Widgets_INCLUDE_DIRS})
        set( MAGICS_QT 1)
        set( MAGICS_QT6 1)
        set( qt yes)
    else()
        find_package(Qt5Widgets REQUIRED)
        if( Qt5Widgets_FOUND )
            ecbuild_info("Qt5 was found ... ${Qt5Widgets_VERSION_STRING}")
            include_directories(${Qt5Widgets_INCLUDE_DIRS})
            set( MAGICS_QT 1)
            set( MAGICS_QT5 1)
            set( qt yes)
        else()
            ecbuild_critical("Neither Qt5 nor Qt6 were found ...")
        endif()
    endif()
endif()

ecbuild_declare_project()

###############################################################################
# find extra packages

ecbuild_find_package( NAME eccodes VERSION 2.24.0 REQUIRED
                      FAILURE_MSG "ecCodes is required in order to build Magics" )
set( HAVE_GRIB 1 )
set( HAVE_BUFR 1 )




# adding NO_MODULE means that if we don't find it, CMake will not generate
# strange error messages about not being able to find the FindProj4.cmake file.
# this should find proj if it has been installed via CMake, but if it has been
# installed via autotools, then we will need to try another method
#ecbuild_find_package(NAME PROJ4 VERSION 6.1.0 QUIET )

# find_package( PROJ4 6.1.0 NO_MODULE )
# if(NOT PROJ4_FOUND)
find_package(PROJ 6.1.0 REQUIRED)
if (NOT PROJ_FOUND)
    message(FATAL_ERROR "Package 'proj' was not found - at least version 6.1.0 required.")
endif()

message("PROJ include: ${PROJ_INCLUDE_DIR}")
message("PROJ library: ${PROJ_LIBRARIES}")
list( APPEND MAGICS_PRIVATE_INCLUDE_DIRS ${PROJ_INCLUDE_DIR})
# endif()


find_package( EXPAT REQUIRED )   # for MagML

if(APPLE)
  find_package( zlib REQUIRED )  # dependency of minizip - KMZ support
endif(APPLE)

### check support for DL library
#
#  code taken from eckit (src/eckit/CMakeList.txt)
#
if( NOT EC_OS_NAME MATCHES "windows" )
check_include_files( dlfcn.h magics_HAVE_DLFCN_H )

if(NOT magics_HAVE_DLFCN_H)
message(FATAL_ERROR "Magics requires dlfcn.h for supporting the detection of the shared folder")
endif()

cmake_push_check_state(RESET)
    set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_DL_LIBS} )
    check_c_source_compiles( "#define _GNU_SOURCE\n#include <dlfcn.h>\nint main(){ void* addr; Dl_info info; dladdr(addr, &info); }\n"
        magics_HAVE_DLADDR )
cmake_pop_check_state()

endif()

###############################################################################
# Windows compiler options

if( EC_OS_NAME MATCHES "windows" )
    # Suppress compliler warnings
    # Suppress warnings about using 'insecure' functions. Fixing this would require changes all over
    # the codebase which would damage portability.
    ecbuild_add_c_flags("/D_CRT_SECURE_NO_WARNINGS")
    ecbuild_add_cxx_flags("/D_CRT_SECURE_NO_WARNINGS")
    # Suppress warnings about using well-known C functions.
    ecbuild_add_c_flags("/D_CRT_NONSTDC_NO_DEPRECATE")
    ecbuild_add_cxx_flags("/D_CRT_NONSTDC_NO_DEPRECATE")
    # For M_PI
    ecbuild_add_c_flags("/D_USE_MATH_DEFINES")
    ecbuild_add_cxx_flags("/D_USE_MATH_DEFINES")
    # Suppress C4267: warns about possible loss of data when converting 'size_t' to 'int'.
    ecbuild_add_c_flags("/wd4267")
    ecbuild_add_cxx_flags("/wd4267")
    # Suppress C4800: forcing value to bool 'true' or 'false'
    ecbuild_add_cxx_flags("/wd4800")
    # Suppress C4244: convertions from double to int
    #ecbuild_add_cxx_flags("/wd4244")
    # Suppress C4244: convertions from double to float
    #ecbuild_add_cxx_flags("/wd4305")

#### /D PROJ_MSVC_DLL_IMPORT

    # Prevent fatal error C1128
    ecbuild_add_cxx_flags("/bigobj")

else()

  # set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-overloaded-virtual -Wno-unused-variable -Wno-reorder -Wno-sign-compare")
  ecbuild_add_cxx_flags("-Wno-unused-parameter" NO_FAIL)
  ecbuild_add_cxx_flags("-Wno-overloaded-virtual" NO_FAIL)
  ecbuild_add_cxx_flags("-Wno-unused-variable" NO_FAIL)
  ecbuild_add_cxx_flags("-Wno-reorder" NO_FAIL)
  ecbuild_add_cxx_flags("-Wno-sign-compare" NO_FAIL)
  # For NVIDIA
  ecbuild_add_cxx_flags("--diag_suppress=partial_override" NO_FAIL)
  ecbuild_add_cxx_flags("--diag_suppress=virtual_function_decl_hidden" NO_FAIL)
  ecbuild_add_cxx_flags("--diag_suppress=code_is_unreachable" NO_FAIL)

  # set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-unused-parameter -Wno-overloaded-virtual -Wno-unused-variable -Wno-reorder-ctor -Wno-sign-compare")

endif()

###############################################################################
# contents

if ( HAVE_ODB )
  ecbuild_info("Adding support for ODB")
  list( APPEND MAGICS_EXTRA_LIBRARIES odccore)
endif()



if( HAVE_CAIRO )
  list( APPEND MAGICS_PRIVATE_INCLUDE_DIRS ${PANGOCAIRO_INCLUDE_DIRS})

  if( EC_OS_NAME MATCHES "windows" )


    # Looks like the transitivity of includes is broken
    find_package(PkgConfig REQUIRED)

    pkg_search_module(GLIB REQUIRED glib-2.0)
    list( APPEND MAGICS_PRIVATE_INCLUDE_DIRS ${GLIB_INCLUDE_DIRS})

    pkg_search_module(CAIRO REQUIRED cairo)
    list( APPEND MAGICS_PRIVATE_INCLUDE_DIRS ${CAIRO_INCLUDE_DIRS})

    pkg_search_module(HARFBUZZ REQUIRED harfbuzz)
    list( APPEND MAGICS_PRIVATE_INCLUDE_DIRS ${HARFBUZZ_INCLUDE_DIRS})

  endif()

endif()

set( MAGICS_LIBRARIES MagPlus )

if( MAGICS_QT )
    if( MAGICS_QT6 )
        list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${Qt6Widgets_INCLUDE_DIR} )
        list( APPEND MAGICS_EXTRA_LIBRARIES     ${Qt6Widgets_LIBRARIES})
    elseif ( MAGICS_QT5 )
        list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${Qt5Widgets_INCLUDE_DIR} )
        list( APPEND MAGICS_EXTRA_LIBRARIES     ${Qt5Widgets_LIBRARIES})
    endif()
    if( WITH_QT_DEBUG )
        list( APPEND MAGICS_EXTRA_DEFINITIONS QT_NO_DEBUG_OUTPUT )
    endif()
endif()

if( HAVE_GEOTIFF )
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS	${GEOTIFF_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES	${GEOTIFF_LIBRARY} )
	list( APPEND MAGICS_EXTRA_DEFINITIONS	HAVE_GEOTIFF )
endif()

if( HAVE_WEBP )
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS	${WEBP_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES ${WEBP_LIBRARY} )
	list( APPEND MAGICS_EXTRA_DEFINITIONS	HAVE_WEBP )
endif()

list( APPEND MAGICS_EXTRA_LIBRARIES     ${CMAKE_THREAD_LIBS_INIT} )

if( EC_OS_NAME MATCHES "windows" )
    # We need to link to ws2_32.lib to avoid an unresolved external (gethostname)
    # It's part of the Windows SDK so no need to search for it.
    list( APPEND MAGICS_EXTRA_LIBRARIES ws2_32 )
    # We need to find zlib.lib
    # find_library( ZLIB_LIB zlib PATHS ENV PATH )
    # list( APPEND MAGICS_EXTRA_LIBRARIES ${ZLIB_LIB} )
    find_package( ZLIB REQUIRED )   # for MagML
    message("ZLIB include: ${ZLIB_INCLUDE_DIR}")
    message("ZLIB library: ${ZLIB_LIBRARIES}")
    list( APPEND MAGICS_EXTRA_LIBRARIES ${ZLIB_LIBRARIES} )
endif()

ecbuild_debug("MAGICS_EXTRA_DEFINITIONS  => ${MAGICS_EXTRA_DEFINITIONS}")
ecbuild_debug("MAGICS_EXTRA_INCLUDE_DIRS => ${MAGICS_EXTRA_INCLUDE_DIRS}")
ecbuild_debug("MAGICS_EXTRA_LIBRARIES    => ${MAGICS_EXTRA_LIBRARIES}")

get_directory_property( MAGICS_DEFINITIONS COMPILE_DEFINITIONS )

add_subdirectory( tools )
add_subdirectory( src )
add_subdirectory( share )
add_subdirectory( apps )
add_subdirectory( test )
if( HAVE_DOCUMENTATION )
  add_subdirectory( docs )
endif()


if(NOT HAVE_EFAS)
  ecbuild_add_resources( TARGET noefas DONT_PACK_DIRS share/magics/efas)
endif()

# Directories not need in the distribution tar ball!
ecbuild_add_resources( TARGET bamboo DONT_PACK_DIRS bamboo)
ecbuild_add_resources( TARGET old_resources
		DONT_PACK_DIRS
		docs
		regression
		toolsjs
		notebook)



############################################################################################
# finalize

set( MAGICS_DESCRIPTION "Multi-platform meteorological graphics library" )
set( MAGICS_URL "https://software.ecmwf.int/magics" )

### print all variables
#get_cmake_property(_variableNames VARIABLES)
#foreach (_variableName ${_variableNames})
#    ecbuild_info("${_variableName}=${${_variableName}}")
#endforeach()

ecbuild_install_project( NAME Magics )

ecbuild_print_summary()

=== requirements.txt ===
# pip requirements file
# pip freeze > requirements.txt
Magics

=== apps/CMakeLists.txt ===

add_subdirectory( metgram )
# if( NOT EC_OS_NAME MATCHES "windows" )
    add_subdirectory( MagMLInterpretor )
# endif()

=== docs/CMakeLists.txt ===
find_package(Doxygen REQUIRED)

# Find all the public headers

list( APPEND MAGICS_DOCS ${PROJECT_SOURCE_DIR}/src/common)
list( APPEND MAGICS_DOCS ${PROJECT_SOURCE_DIR}/src/basic)



set(DOXYGEN_INPUT_DIR ${PROJECT_SOURCE_DIR}/src)
set(DOXYGEN_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/docs/doxygen)
set(DOXYGEN_INDEX_FILE ${DOXYGEN_OUTPUT_DIR}/xml/index.xml)
set(DOXYFILE_IN ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
set(DOXYFILE_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

message("DOXYGEN: ${DOXYGEN_INPUT_DIR}")
message("DOXYGEN: ${DOXYGEN_OUTPUT_DIR}")
message("DOXYGEN: ${MAGICS_DOCS}")
message("DOXYGEN: ${DOXYGEN_INDEX_FILE}")
message("DOXYGEN: ${DOXYGEN_EXECUTABLE}")

#Replace variables inside @@ with the current values
configure_file(${DOXYFILE_IN} ${DOXYFILE_OUT} @ONLY)

file(MAKE_DIRECTORY ${DOXYGEN_OUTPUT_DIR}) #Doxygen won't create this for us

add_custom_command(OUTPUT ${DOXYGEN_INDEX_FILE}
                   DEPENDS ${MAGICS_DOCS}
                   COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE_OUT}
                   MAIN_DEPENDENCY ${DOXYFILE_OUT} ${DOXYFILE_IN}
                   COMMENT "Generating docs"
                   VERBATIM)

add_custom_target(Doxygen ALL DEPENDS ${DOXYGEN_INDEX_FILE})

find_package(Sphinx REQUIRED)

set(SPHINX_SOURCE ${CMAKE_CURRENT_SOURCE_DIR})
set(SPHINX_BUILD ${CMAKE_CURRENT_BINARY_DIR}/sphinx)
set(SPHINX_INDEX_FILE ${SPHINX_BUILD}/index.html)

add_custom_command(OUTPUT ${SPHINX_INDEX_FILE}
                   COMMAND 
                     ${SPHINX_EXECUTABLE} -b html
                     # Tell Breathe where to find the Doxygen output
                     -Dbreathe_projects.magics=${DOXYGEN_OUTPUT_DIR}/xml
                   ${SPHINX_SOURCE} ${SPHINX_BUILD}
                   WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                   DEPENDS
                   # Other docs files you want to track should go here (or in some variable)
                   ${CMAKE_CURRENT_SOURCE_DIR}/index.rst
                   ${CMAKE_CURRENT_SOURCE_DIR}/parameters.rst
                   ${CMAKE_CURRENT_SOURCE_DIR}/decoders.rst
                   ${CMAKE_CURRENT_SOURCE_DIR}/drivers.rst
                   ${CMAKE_CURRENT_SOURCE_DIR}/visualisers.rst
                   ${CMAKE_CURRENT_SOURCE_DIR}/documentation.rst
                   ${DOXYGEN_INDEX_FILE}
                   MAIN_DEPENDENCY ${SPHINX_SOURCE}/conf.py
                   COMMENT "Generating documentation with Sphinx")

# Nice named target so we can run the job easily
add_custom_target(Sphinx ALL DEPENDS ${SPHINX_INDEX_FILE})


# Add an install target to install the docs
include(GNUInstallDirs)
install(DIRECTORY ${SPHINX_BUILD}
DESTINATION ${CMAKE_INSTALL_DOCDIR})

=== regression/CMakeLists.txt ===

if( NOT ENABLE_REGRESSION ) 
	return()
endif()

set( REGRESSION_SCRIPT_DIRECTORY  ${CMAKE_CURRENT_SOURCE_DIR} )

#set tests timestamp
execute_process(COMMAND date +\"%Y%m%d_%H%M%S\" OUTPUT_VARIABLE TIMESTAMP)
STRING(REGEX REPLACE "\"" "" TIMESTAMP ${TIMESTAMP})
STRING(REGEX REPLACE "\n" "" TIMESTAMP ${TIMESTAMP})

#set( summary_depend "")

function( add_magics_test )

    set( options PYTHON  JSON MAGML)
    set( single_value_args NAME IMAGE THRESHOLD)
    set( multi_value_args  SOURCES DATA RESOURCES )
    cmake_parse_arguments( _p "${options}" "${single_value_args}" "${multi_value_args}"  ${_FIRST_ARG} ${ARGN} )

    if(_p_UNPARSED_ARGUMENTS)
      message(FATAL_ERROR "Unknown keywords given to add_magics_test(): \"${_p_UNPARSED_ARGUMENTS}\"")
    endif()
    
    ### check parameters

    if( NOT _p_NAME )
      message(FATAL_ERROR "add_magics_test() expects a NAME")
    endif()

    if( NOT _p_IMAGE )
      message(FATAL_ERROR "add_magics_test() expects a IMAGE")
    endif()
    if( NOT _p_THRESHOLD )
      set(_p_THRESHOLD "20")
    endif()
    
    list(APPEND tools "report_template.html")
    list(APPEND tools "summary_template.html")    
    
   	foreach( file ${tools} )
          execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/../${file} ${CMAKE_CURRENT_BINARY_DIR} )
    endforeach()
    
	get_filename_component(where ${CMAKE_CURRENT_SOURCE_DIR} NAME )
    set( targets "" )
	foreach( data ${_p_DATA} )
        string( REGEX REPLACE "[^A-Za-z0-9_]" "_" target "${_p_NAME}_data_${data}" )
        ecbuild_get_test_data( NAME ${data} TARGET ${target} NOCHECK 
            DIRNAME magics/regression/${where})
        list( APPEND targets  "${target}")
	endforeach()

	set( versions "" ) 


	get_filename_component(log ${_p_IMAGE} NAME_WE)
             
	
	foreach( version ${MAGICS_REFERENCE_VERSIONS} )
	    
		set( file ${version}_${_p_IMAGE} )	 
		set( err ${version}_${log}.err )
		set( out ${version}_${log}.out )	
		set( usa ${version}_${log}.usa )
		set (todos)  
		list (APPEND todos ${file})
		list (APPEND todos ${err})
		list (APPEND todos ${out})
		list (APPEND todos ${usa})		
		foreach ( todo  ${todos} )
        	string( REGEX REPLACE "[^A-Za-z0-9_]" "_" target "test_data_${todo}" )
        	list( APPEND targets "${target}")
	    
			ecbuild_get_test_data( NAME ${todo} NOCHECK 
				DIRNAME magics/reference/${version}/${where} )
		endforeach()
	
		set( versions "${versions}${version} " )
	 
	endforeach()

	
	set(target "magics_a_${_p_NAME}")

	#summary depends of all previous tests
    #list(APPEND summary_depend "${target}")
	
	set(target_load "magics_load_${_p_NAME}")
	
	list(APPEND _p_RESOURCES ${_p_SOURCES} )

    if( _p_PYTHON )
	    
		 if ( ENABLE_REGRESSION_UPLOAD ) 
			ecbuild_add_test(  TARGET   ${target_load}
                   TYPE SCRIPT
                   COMMAND  ${REGRESSION_SCRIPT_DIRECTORY}/upload.py
                   DEPENDS  ${targets}                     
                   RESOURCES  ${_p_RESOURCES} 
                   ARGS ${MAGICS_VERSION} ${_p_SOURCES} ${_p_IMAGE} magics/reference/${MAGICS_VERSION}/${where} -i python
                   ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH} )
         endif()
         
         ecbuild_add_test(  TARGET   ${target}
                   TYPE SCRIPT
                   COMMAND  ${REGRESSION_SCRIPT_DIRECTORY}/compare.py
                   DEPENDS  ${targets}  
                   RESOURCES  ${_p_RESOURCES} 
                   ARGS ${TIMESTAMP} ${_p_SOURCES} ${_p_IMAGE} -n ${BRANCH_NAME} -t ${_p_THRESHOLD}  -o ${MAGICS_HTML_ROOT}  -v ${versions} -f -i python
            ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH} )
        
            return() 
    endif()
	if( _p_MAGML )
	       if ( ENABLE_REGRESSION_UPLOAD ) 
				ecbuild_add_test(  TARGET   ${target_load}
                   TYPE SCRIPT
                   COMMAND  ${REGRESSION_SCRIPT_DIRECTORY}/upload.py
                   DEPENDS  ${targets} 
                   
                   RESOURCES  ${_p_RESOURCES} 
                   ARGS ${MAGICS_VERSION} ${_p_SOURCES} ${_p_IMAGE} magics/reference/${MAGICS_VERSION}/${where} -i ${CMAKE_BINARY_DIR}/bin/magmlx
				 )
            endif()     
			ecbuild_add_test(  TARGET   ${target}
                   TYPE SCRIPT
                   COMMAND  ${REGRESSION_SCRIPT_DIRECTORY}/compare.py
                   DEPENDS  ${targets}  
                   RESOURCES  ${_p_RESOURCES} 
                   ARGS ${TIMESTAMP} ${_p_SOURCES} ${_p_IMAGE}  -n ${BRANCH_NAME} -t ${_p_THRESHOLD}  -o ${MAGICS_HTML_ROOT}  -v ${versions} -i ${CMAKE_BINARY_DIR}/bin/magmlx -f
					ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH} )
            return()
	endif()
	if( _p_JSON )
	       if ( ENABLE_REGRESSION_UPLOAD ) 
				ecbuild_add_test(  TARGET   ${target_load}
                   TYPE SCRIPT
                   COMMAND  ${REGRESSION_SCRIPT_DIRECTORY}/upload.py
                   DEPENDS  ${targets} 
                   
                   RESOURCES  ${_p_RESOURCES} 
                   ARGS ${MAGICS_VERSION} ${_p_SOURCES} ${_p_IMAGE} magics/reference/${MAGICS_VERSION}/${where} -i ${CMAKE_BINARY_DIR}/bin/magjsonx
				 )
            endif()     
			ecbuild_add_test(  TARGET   ${target}
                   TYPE SCRIPT
                   COMMAND  ${REGRESSION_SCRIPT_DIRECTORY}/compare.py
                   DEPENDS  ${targets}  
                   RESOURCES  ${_p_RESOURCES} 
                   ARGS ${TIMESTAMP} ${_p_SOURCES} ${_p_IMAGE}  -n ${BRANCH_NAME} -t ${_p_THRESHOLD}  -o ${MAGICS_HTML_ROOT}  -v ${versions} -i ${CMAKE_BINARY_DIR}/bin/magjsonx -f
					ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH} )
            return()
	endif()
# Run Test
		if ( ENABLE_REGRESSION_UPLOAD ) 
           
			ecbuild_add_test(  TARGET   ${target_load}
                   TYPE          SCRIPT
                   SOURCES       ${_p_SOURCES}                    
                   PRIVATE_LIBS  MagPlus MagPlusSingle ${MAGICS_EXTRA_LIBRARIES} 
                   DEPENDS       ${targets}
                   RESOURCES     ${_p_RESOURCES} 
                   COMMAND       ${REGRESSION_SCRIPT_DIRECTORY}/upload.py  
                   ARGS          ${MAGICS_VERSION} ./${target} ${_p_IMAGE} magics/reference/${MAGICS_VERSION}/${where} ) 
		endif()
	    ecbuild_add_test(  TARGET  ${target}
                   TYPE          SCRIPT
                   SOURCES       ${_p_SOURCES}                    
                   PRIVATE_LIBS  MagPlus MagPlusSingle ${MAGICS_EXTRA_LIBRARIES} 
                   DEPENDS       ${targets}
                   RESOURCES     ${_p_RESOURCES} 
                   COMMAND       ${REGRESSION_SCRIPT_DIRECTORY}/compare.py  
                   ARGS          ${TIMESTAMP} ./${target} ${_p_IMAGE}  -n ${BRANCH_NAME}  -t ${_p_THRESHOLD}  -o ${MAGICS_HTML_ROOT}  -v ${versions} -f )

endfunction(add_magics_test)


add_subdirectory( basic )
add_subdirectory( efas )
add_subdirectory( macc )
add_subdirectory( plumes )
add_subdirectory( axis )
add_subdirectory( contour )
add_subdirectory( web )
add_subdirectory( data )
add_subdirectory( metops )
add_subdirectory( wind )
add_subdirectory( graph )
add_subdirectory( layout )
add_subdirectory( rotated )
add_subdirectory( proj4 )
add_subdirectory( venice )
add_subdirectory( era )
add_subdirectory( symbol )

#final test 
ecbuild_add_test(  TARGET    magics_summary
                   TYPE      PYTHON
                   DEPENDS   ${summary_depend}
                   RESOURCES summary_template.html
                   COMMAND   ${CMAKE_CURRENT_SOURCE_DIR}/summary.py
                   ARGS      ${MAGICS_HTML_ROOT} 
                   )

=== regression/axis/CMakeLists.txt ===
# magics test executable run in script

add_magics_test(NAME axis01 SOURCES axis01.F IMAGE axis01.ps THRESHOLD 2)
add_magics_test(NAME axis02 SOURCES axis02.F IMAGE axis02.ps THRESHOLD 2)
add_magics_test(NAME automatic_axis SOURCES automatic_axis.F IMAGE automatic_axis.ps THRESHOLD 2)

=== regression/basic/CMakeLists.txt ===
# magics test executable run in script

add_magics_test(NAME basic SOURCES basic.c IMAGE basic.png DATA data.grib ) 
add_magics_test(NAME contour SOURCES contour.f IMAGE contour.ps DATA z500.grb THRESHOLD 50)
add_magics_test(NAME graph SOURCES graph.json RESOURCES data.json IMAGE graph.png THRESHOLD 10 JSON)

=== regression/contour/CMakeLists.txt ===


#Extensive contour testing



list ( APPEND zs  cont_attributes_ex  cont_auto_ex cont_cellshade_test1 cont_dotshade_test1 cont_hatchshade_ex cont_linestyles_ex cont_markershade_ex cont_gridshade_test1 cont_labels cont_noshade_ex cont_solidshade_ex cont_solidshade_test1 cont_simple)

foreach( z ${zs} )
    add_magics_test(NAME contour_${z} SOURCES ${z}.F IMAGE ${z}.ps   THRESHOLD 2)
endforeach()

add_magics_test(NAME contour_cont08 SOURCES cont08.F IMAGE cont08.ps  DATA z500.grb THRESHOLD 2)
add_magics_test(NAME contour_alternate SOURCES cont_alternate.F IMAGE cont_alternate.ps  DATA t300.grb THRESHOLD 2)
add_magics_test(NAME contour_auto_t1279 SOURCES cont_auto_t1279.F IMAGE cont_auto_t1279.ps  DATA t1279_gg640_lev85.grib THRESHOLD 2)
add_magics_test(NAME contour_auto_t799 SOURCES cont_auto_t799.F IMAGE cont_auto_t799.ps  DATA t799_ll.grib THRESHOLD 2)
add_magics_test(NAME contour_flat_field_1 SOURCES cont_flat_field_1.F IMAGE cont_flat_field_1.ps  DATA cloudcover.grib THRESHOLD 2)
add_magics_test(NAME contour_gridvals_ex SOURCES cont_gridvals_ex.F IMAGE cont_gridvals_ex.ps  DATA r850.grb THRESHOLD 2)
add_magics_test(NAME contour_methods_ex SOURCES cont_methods_ex.F IMAGE cont_methods_ex.ps   THRESHOLD 2)
add_magics_test(NAME contour_res_ex SOURCES cont_res_ex.F IMAGE cont_res_ex.ps   THRESHOLD 2)
add_magics_test(NAME contour_akima_example SOURCES cont_akima_example.F IMAGE cont_akima_example.ps  DATA rh850.grib THRESHOLD 2)
add_magics_test(NAME contour_solidshade_test2 SOURCES cont_solidshade_test2.F IMAGE cont_solidshade_test2.ps   THRESHOLD 2)
add_magics_test(NAME contour_missing SOURCES cont_missing.F IMAGE cont_missing.ps   DATA sst.grib THRESHOLD 2)
add_magics_test(NAME contour_missing_2 SOURCES cont_missing_2.F IMAGE cont_missing_2.ps  DATA CWAO_Z.grib THRESHOLD 2)
add_magics_test(NAME contour_solidshade_test3 SOURCES cont_solidshade_test3.F IMAGE cont_solidshade_test3.ps  DATA lsp25.grib THRESHOLD 2)
add_magics_test(NAME contour_split SOURCES cont_split.F IMAGE cont_split.ps  DATA Tdiff.grib THRESHOLD 2)

=== regression/data/CMakeLists.txt ===
add_magics_test(NAME data_gaussian SOURCES data_gaussian.F IMAGE data_gaussian.ps DATA  regular_gaussian_q300.grib gaussian_q300.grib  THRESHOLD 5)
add_magics_test(NAME data_grib2 SOURCES data_grib2.F IMAGE data_grib2.ps DATA 10_meter_v_velocity_fc_sfc_grib2.grib temperature_fc_pl_grib2.grib THRESHOLD 5)
add_magics_test(NAME data_gribs SOURCES data_gribs.F IMAGE data_gribs.ps DATA  EPS_27.grib pot_temp_system3.grib   THRESHOLD 5)
add_magics_test(NAME data_hirlam SOURCES data_hirlam.F IMAGE data_hirlam.ps 
                    DATA hirlam-sweden-t.grb hirlam-sweden-uv.grb hirlam-iceland-t.grb hirlam-iceland-uv.grb  THRESHOLD 5)
add_magics_test(NAME data_invalid_values SOURCES data_invalid_values.F IMAGE data_invalid_values.ps DATA t2m_masked.grib t2m_masked_1_5.grib THRESHOLD 5)
add_magics_test(NAME data_rgg640 SOURCES data_rgg640.F IMAGE data_rgg640.ps DATA  rgg640.grib   THRESHOLD 5)
add_magics_test(NAME data_rll_1-deg SOURCES data_rll_1-deg.F IMAGE data_rll_1-deg.ps DATA  prob_icefreesee_0101.grib   THRESHOLD 5)
add_magics_test(NAME data_t1279_gg640 SOURCES data_t1279_gg640.F IMAGE data_t1279_gg640.ps DATA t1279_gg640_lev85.grib   THRESHOLD 5)
add_magics_test(NAME data_t1279_gg640_cell SOURCES data_t1279_gg640_cell.F IMAGE data_t1279_gg640_cell.ps DATA   t1279_gg640_lev85.grib   THRESHOLD 5)
add_magics_test(NAME data_t3999_rgg2000 SOURCES data_t3999_rgg2000.F IMAGE data_t3999_rgg2000.ps DATA  orog.3999.grib   THRESHOLD 5)
add_magics_test(NAME data_t799 SOURCES data_t799.F IMAGE data_t799.ps DATA t799_ll.grib   THRESHOLD 5)
add_magics_test(NAME data_t799_t2m SOURCES data_t799_t2m.F IMAGE data_t799_t2m.ps DATA   t799_t2m_ll.grib   THRESHOLD 5)
add_magics_test(NAME dataonly_linear SOURCES dataonly_linear.F IMAGE dataonly_linear.ps DATA z500.grb  THRESHOLD 5)

=== regression/graph/CMakeLists.txt ===
add_magics_test(NAME graph_bar SOURCES bar.F IMAGE bar.ps    THRESHOLD 2)
add_magics_test(NAME graph_boxplot_ex SOURCES boxplot_ex.F IMAGE boxplot_ex.ps     THRESHOLD 2)
add_magics_test(NAME graph_graf01 SOURCES graf01.F IMAGE graf01.ps     THRESHOLD 2)
add_magics_test(NAME graph_graf02 SOURCES graf02.F IMAGE graf02.ps    THRESHOLD 2)
add_magics_test(NAME graph_graf03 SOURCES graf03.F IMAGE graf03.ps     THRESHOLD 2)
add_magics_test(NAME graph_graf04 SOURCES graf04.F IMAGE graf04.ps     THRESHOLD 2)

add_magics_test(NAME graph_lines SOURCES graph_lines.F IMAGE graph_lines.ps  THRESHOLD 2)





#add_magics_test(NAME graph_venice_01 SOURCES graph_venice_01.f IMAGE graph_venice_01.ps 
#            DATA TOWER.ope_2010 WAS_RES.2010 THRESHOLD 2)
#add_magics_test(NAME graph_venice_02 SOURCES graph_venice_02.F IMAGE graph_venice_02.ps  
#            DATA ANCON.ope_2010 MONOP.ope_2010 PESCA.ope_2010 POMAE.ope_2010 graph_venice_02_stdin.txt THRESHOLD 2)

=== regression/layout/CMakeLists.txt ===
add_magics_test(NAME layout_6_plots SOURCES layout_6_plots.F IMAGE layout_6_plots.ps DATA z500.grb  THRESHOLD 50)
add_magics_test(NAME layout_auto_ex SOURCES layout_auto_ex.F IMAGE layout_auto_ex.ps DATA z500.grb  THRESHOLD 50)
add_magics_test(NAME layout_manual_2 SOURCES layout_manual_2.F IMAGE layout_manual_2.ps DATA z500.grb  THRESHOLD 50)
add_magics_test(NAME layout_manual_ex SOURCES layout_manual_ex.F IMAGE layout_manual_ex.ps DATA z500.grb  THRESHOLD 50)

=== regression/macc/CMakeLists.txt ===
# magics test executable run in script



add_magics_test(NAME macc_geomap
                SOURCES geomap.json
                RESOURCES geodata.json
                IMAGE geomap.png
                THRESHOLD 1
                JSON)

add_magics_test(NAME macc_graph
                SOURCES graph.json
                RESOURCES xydata.json
                IMAGE macc_graph.png
                THRESHOLD 1
                JSON)

add_magics_test(NAME macc_symb
                SOURCES symb.json
                RESOURCES xydata.json
                IMAGE macc_symb.png
                THRESHOLD 1
                JSON)

add_magics_test(NAME macc_taylor
                SOURCES taylor.json
                RESOURCES taylordata.json
                IMAGE macc_taylor.png
                THRESHOLD 1
                JSON)
add_magics_test(NAME macc_diagonal
                SOURCES diagonal.json
                RESOURCES diagonal.data
                IMAGE diagonal.png
                THRESHOLD 1
                JSON)

=== debian/changelog ===
magics++ (4.16.0+really4.16.0-3) unstable; urgency=medium

  * Build without emoslib
  * Standards-Version: 4.7.3
  * Drop redundant Priority: optional

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 27 Jan 2026 19:42:05 +0000

magics++ (4.16.0+really4.16.0-2) unstable; urgency=medium

  * Fix FTBFS with GCC-15 (c++15.patch). Closes: #1097351

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 06 Sep 2025 12:39:02 +0100

magics++ (4.16.0+really4.16.0-1) unstable; urgency=medium

  * Reupload 4.16.0 to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Aug 2025 10:32:17 +0100

=== debian/control ===
Source: magics++
Section: science
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat  (= 13) , 
 architecture-is-64-bit,
 dh-fortran-mod (>= 0.31),
 ecbuild (>= 3.3.0-3),
 pkgconf,
 python3-all-dev,
 libxcb-xkb-dev,
 libhdf5-dev | libhdf5-mpi-dev, 
 libnetcdf-dev,
 libgeotiff-dev,
 libgl-dev, libgd-dev, 
 libeccodes-dev (>= 2.13.0-3),
 libeccodes-tools,
 libodc-dev,
 odc,
 libopenjp2-7-dev,
 libaec-dev,
 libterralib-dev, 
 libcairo2-dev, 
 libpango1.0-dev,
 fonts-dejavu-core, 
 libxml-parser-perl, 
 ghostscript, 
 zlib1g-dev, 
 libboost-dev | libboost1.83-dev, 
 qt6-base-dev,
 libqt6core5compat6-dev,
 libqt6svg6-dev,
 python3-jinja2
Standards-Version: 4.7.3
Homepage: https://software.ecmwf.int/wiki/display/MAGP/Magics
Vcs-Browser: https://salsa.debian.org/science-team/magics.git
Vcs-Git: https://salsa.debian.org/science-team/magics.git -b debian/latest

Package: libmagplus3v5
Section: libs
Architecture: any
Multi-Arch: same
Depends: libmagics++-data,${misc:Depends}, ${shlibs:Depends}, fonts-dejavu-core, fonts-dejavu-extra, ghostscript
Description: ECMWF meteorological plotting software library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 The library supports the plotting of contours, wind fields, observations,
 satellite images, symbols, text, axis and graphs (including boxplots).
 .
 Data fields to be plotted may be presented in various formats,
 for instance GRIB 1 and 2 code data, Gaussian grid, regularly spaced grid
 and fitted data. Input data can also be in BUFR and NetCDF format
 or retrieved from an ODB database.
 .
 The produced meteorological plots can be saved in various formats,
 such as PostScript, EPS, PDF, GIF, PNG, SVG and KML.

Package: libmagics++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmagplus3v5 ( = ${binary:Version} ), 
 ${misc:Depends}, ${ecbuild:Depends},
 python3, libmagics++-metview-dev, libterralib-dev, magics++,
 libodc-dev [!powerpc !armel !armhf !hppa !i386 !mipsel]
Recommends: pkgconf
Description: Development files for ECMWF  plotting software MAGICS++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package includes the header files and static libraries needed to build 
 against libmagics++.

Package: magics++
Architecture: any
Multi-Arch: foreign
Depends: libmagplus3v5 ( = ${binary:Version} ),
 ${perl:Depends}, ${misc:Depends}, ${shlibs:Depends}, python3
Description: Executables for the magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package contains the MagcML binary that may be used with magics++.


Package: libmagics++-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data files needed for magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package contains data expected by the magics++ library.


Package: libmagics++-metview-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmagplus3v5 ( = ${binary:Version} )
Description: Libraries needed for building MetView
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package includes the header files and static libraries needed to build
 metview against magics++.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/debhelper/dh-fortran/fortran-support.mk

# To enable all, uncomment following line
# DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-pie
CXXFLAGS:= -fPIC $(shell dpkg-buildflags --get CXXFLAGS) # -std=c++14
# CFLAGS:= -fPIC $(shell dpkg-buildflags --get CFLAGS) 
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Set for build reproducibility
LC_ALL=C
export LC_ALL

LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
CMAKEDIR:=debian/tmp/$(LIBDIR)/cmake/magics

%:
	dh $@ --with-buildsystem=ecbuild

export extra_flags +=  \
	-DBUILD_SITE=debian \
	-DENABLE_LIBGD=1 \
	-DHAVE_BOOST=1 \
	-DENABLE_ODB=On \
	-DENABLE_EFAS=1 \
	-DHAVE_DLFCN_H=1 \
	-DHAVE_INTTYPES_H=1 \
	-DHAVE_LIBEXPAT=1 \
	-DHAVE_LIBPROJ=1 \
	-DHAVE_LIBPTHREAD=1 \
	-DHAVE_LIBZ=1 \
	-DHAVE_MEMORY_H=1 \
	-DHAVE_STDINT_H=1 \
	-DHAVE_STDLIB_H=1 \
	-DHAVE_STRINGS_H=1 \
	-DHAVE_STRING_H=1 \
	-DHAVE_SYS_STAT_H=1 \
	-DHAVE_STS_TYPES_H=1 \
	-DHAVE_UNISTD_H=1 \
	-DMAGICS_ALLHEADERS=1 \
	-DMAGICS_GRIB=1 \
	-DMAGICS_JSON=1 \
	-DMAGICS_GIF=1 \
	-DMAGICS_GIF_ANIMATED=1 \
	-DMAGICS_TIFF=1 \
	-DMAGICS_TTF=1 \
	-DMAGICS_TTF_PATH="share/magics/ttf/" \
	-DMAGICS_SITE="debian" \
	-DMAGICS_THREADS=1 \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DBUILD_DOCUMENTATION=ON \
	-DENABLE_FORTRAN=ON \
	-DENABLE_LARGE_FILE_SUPPORT=ON \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DENABLE_TESTS=ON \
	-DENABLE_GEOTIFF=ON \
	-DGEOTIFF_INCLUDE_DIR=/usr/include/geotiff \
	-DXKB_INCLUDE_DIR=/usr/include/xkb \
	-DENABLE_RPATHS=OFF \
	-DENABLE_CAIRO=ON \
	-DENABLE_BUFR=ON \
	-DENABLE_GRIB=ON \
	-DENABLE_METVIEW=ON \
	-DENABLE_NETCDF=ON \
	-DCMAKE_C_FLAGS='$(CFLAGS) ' \
	-DCMAKE_CXX_FLAGS='$(CXXFLAGS) -I/usr/include/terralib -I/usr/include/terralib/kernel -I/usr/include/geotiff -I/usr/include/xkb' \
	-DMAGICS_EXTRA_LIBRARIES='-lterralib -lgd' 

export LD_LIBRARY_PATH:=$(CURDIR)/debian/tmp/usr/lib:$(LD_LIBRARY_PATH)

override_dh_auto_clean:
	# remove Makefile: it attempts a Docker build from git ...
	rm -f Makefile
	rm -rf debian/build-py* build/*x
	rm -f bin/magjsonx  bin/magmlx  bin/metgramx
	find . -type l -delete
	find . -name '.DS_Store' -delete
	rm -f src/params/*.h src/decoders/*Attributes.h
	rm -rf share/magics/ttf src/terralib debian/build src/boost

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)
	# link for font for tesing.
	mkdir -p share/fonts/truetype/ttf-dejavu/
	ln -sf /usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf share/fonts/truetype/ttf-dejavu/
	# Link terralib
	[ -e src/terralib ] || ln -sf  /usr/include/terralib src/terralib

override_dh_auto_test check:
	# echo "Tests disabled; see README-testfailures.txt for details"
	#(ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py3/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py3  check )

override_dh_auto_install:
	dh_auto_install 
	# sed -i -e 's%$${_IMPORT_PREFIX}/${LIBDIR}%${LIBDIR}%g' $(CMAKEDIR)/magics-targets-none.cmake
	#sed -i -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%g'  $(CMAKEDIR)/magics-targets-none.cmake
	sed -i -e 's%${CURDIR}%/build/magics++%g'       $(CMAKEDIR)/magics-config.cmake 
	sed -i -e 's%${CURDIR}%/build/magics++%g'       $(CMAKEDIR)/magics-import.cmake 
	#sed -i -e 's%$${_IMPORT_PREFIX}/include/magics%/usr/include/magics%g' $(CMAKEDIR)/magics-targets.cmake
	sed -i -e 's%$${CURDIR}%/build/magics++%g' $(CMAKEDIR)/magics-import.cmake 
	-find debian/tmp/usr/bin -type f  -exec chrpath -d {} \;
	-find debian/tmp debian/libmagplus3v5   -name '*.so*' -exec chrpath -d {} \;

override_dh_makeshlibs:
	# For new symbols when compiled with GCC 7
	dh_makeshlibs -V'libmagplus3v5 (>= 2.34.1-2~)'
